image: docker/compose:latest
services:
  - docker:dind
    
variables:
  APP_NAME: togetherbiz
  DOMAIN_NAME: together.biz
  ARTIFACT_NAME: $APP_NAME-test-$CI_PIPELINE_IID.jar
  DNSSUBDOMAIN: stage-$CI_PIPELINE_IID
  SUBDOMAIN_NAME: $DNSSUBDOMAIN.$DOMAIN_NAME
  STAGE1SERVER: stage1.together.biz
  STAGE1DOMAIN: stage.actionbox.net
  DEV1SERVER: dev-1.actionbox.net
  DEV1DOMAIN: dev.actionbox.net
  PROD1SERVER: prod1.together.biz
  PROD1DOMAIN: together.biz
  

stages:
- build.all
- deploy.all

build_dev.all:
 stage: build.all
 only:
    - "DevOps"
 script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker version
    - docker-compose version
    - cp production.env .env
    - sed -i -e "s/together.localhost/$DEV1DOMAIN/" .env
    - sed -i -e "s/sentry-release/${CI_COMMIT_SHA}/" .env
    - sed -i -e "s/sentry-environment/development/" .env
    - sed -i -e "s/VERNUM/$CI_PIPELINE_ID/" ./docker-compose.yml	  
    - docker-compose -f docker-compose.yml build
    - docker-compose -f docker-compose.yml push

deploy_dev.all:
 stage: deploy.all
 image: dtzar/helm-kubectl
 only:
    - "DevOps"
 script:
    - kubectl config set-cluster k8s --server=$K8S_SERVER
    - kubectl config set-credentials together --token=$K8S_TOKEN
    - kubectl config set-context default --cluster=k8s --user=$K8S_USER
    - kubectl config use-context default
## directus deployment
    - sed -i -e "s/VERNUM/$CI_PIPELINE_ID/" -e "s/JOBNUM/$CI_JOB_ID/" devops/directus-deployment.yaml
    - kubectl apply -f devops/directus-deployment.yaml -n dev
    - if ! kubectl rollout status deployment directus -n dev; then
    - kubectl describe pod -l cijobid=number_$CI_JOB_ID -n dev | tail
    - kubectl logs  -l cijobid=number_$CI_JOB_ID -n dev
    - kubectl rollout undo deployment directus -n dev 
    - kubectl rollout status deployment directus -n dev
    - exit 1
    - fi
##coliseus deployment
    - sed -i -e "s/VERNUM/$CI_PIPELINE_ID/" -e "s/JOBNUM/$CI_JOB_ID/" devops/colyseus-deployment.yaml
    - kubectl apply -f devops/colyseus-deployment.yaml -n dev
    - if ! kubectl rollout status deployment colyseus -n dev; then
    - kubectl describe pod -l cijobid=number_$CI_JOB_ID -n dev | tail
    - kubectl logs  -l cijobid=number_$CI_JOB_ID -n dev
    - kubectl rollout undo deployment colyseus -n dev 
    - kubectl rollout status deployment colyseus -n dev
    - exit 1
    - fi
##textpad deployment
    - sed -i -e "s/VERNUM/$CI_PIPELINE_ID/" -e "s/JOBNUM/$CI_JOB_ID/" devops/textpad-deployment.yaml
    - kubectl apply -f devops/textpad-deployment.yaml -n dev
    - if ! kubectl rollout status deployment textpad -n dev; then
    - kubectl describe pod -l cijobid=number_$CI_JOB_ID -n dev | tail
    - kubectl logs  -l cijobid=number_$CI_JOB_ID -n dev
    - kubectl rollout undo deployment textpad -n dev 
    - kubectl rollout status deployment textpad -n dev
    - exit 1
    - fi
##clinet-application deployment
    - sed -i -e "s/VERNUM/$CI_PIPELINE_ID/" -e "s/JOBNUM/$CI_JOB_ID/" devops/clinet-deployment.yaml
    - kubectl apply -f devops/clinet-deployment.yaml -n dev
    - if ! kubectl rollout status deployment clinet -n dev; then
    - kubectl describe pod -l cijobid=number_$CI_JOB_ID -n dev | tail
    - kubectl logs  -l cijobid=number_$CI_JOB_ID -n dev
    - kubectl rollout undo deployment clinet -n dev 
    - kubectl rollout status deployment clinet -n dev
    - exit 1
    - fi


